Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim dir_name As String = Application.StartupPath
        If dir_name.EndsWith("\bin\Debug") Then dir_name = dir_name.Substring(0, dir_name.Length - 9)
        If Not dir_name.EndsWith("\") Then dir_name &= "\"
        txtInputFile.Text = dir_name & "unsorted.txt"
        txtOutputFile.Text = dir_name & "sorted.txt"
    End Sub

    Private Sub btnSort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSort.Click
        ' Read the input file.
        Dim lines() As String = System.IO.File.ReadAllLines(txtInputFile.Text)

        ' Make a column sorter.
        ' Note: Columns start numbering from 0.
        Dim column_comparer As New ColumnSorter(-1, 2)

        ' Sort.
        Array.Sort(lines, column_comparer)

        ' Save the result.
        System.IO.File.WriteAllLines(txtOutputFile.Text, lines)

        MessageBox.Show("Done")
    End Sub
End Class

Public Class ColumnSorter
    Implements IComparer(Of String)

    Private m_Columns() As Integer

    ' Save the column numbers for sorting.
    Public Sub New(ByVal ParamArray numbers() As Integer)
        m_Columns = numbers
    End Sub

    ' Compare based on the columns.
    Public Function Compare(ByVal x As String, ByVal y As String) As Integer Implements System.Collections.Generic.IComparer(Of String).Compare
        ' Split the strings into fields.
        Dim x_fields() As String = x.Split(New String() {" "}, StringSplitOptions.RemoveEmptyEntries)
        Dim y_fields() As String = y.Split(New String() {" "}, StringSplitOptions.RemoveEmptyEntries)

        ' Compare the columns.
        For i As Integer = 0 To m_Columns.GetUpperBound(0)
            Dim col As Integer = m_Columns(i)
            If col < 0 Then
                ' Sort descending.
                col = -col
                If x_fields(col) < y_fields(col) Then Return 1
                If x_fields(col) > y_fields(col) Then Return -1
            Else
                ' Sort ascending.
                If x_fields(col) < y_fields(col) Then Return -1
                If x_fields(col) > y_fields(col) Then Return 1
            End If
        Next i
        Return 0
    End Function
End Class